<?php
//###########################################################################
//#																			#
//#				 		Account Switcher 1.0								#
//#					   Copyright  2011 Harest								#
//#																			#
//#			Allows users to switch between multiple accounts.				#
//#																			#
//#		This program is free software: you can redistribute it and/or 		#
//#		modify it under the terms of the GNU General Public License as 		#
//#		published by the Free Software Foundation, either version 3 of 		#
//#		the License, or (at your option) any later version.					#
//#																			#
//#		This program is distributed in the hope that it will be useful, 	#
//#		but WITHOUT ANY WARRANTY; without even the implied warranty of 		#
//#		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  				#
//#		See the GNU General Public License for more details.				#
//#																			#
//#		You should have received a copy of the GNU General Public License 	#
//#		along with this program.  											#
//#		If not, see <http://www.gnu.org/licenses/>.							#
//#																			#
//###########################################################################

if(!defined("IN_MYBB"))
	die("Bow ties are cool.");

$plugins->add_hook("usercp_menu", "accountswitcher_usercpmenu", 40);
$plugins->add_hook("usercp_start", "accountswitcher_usercp");
$plugins->add_hook("global_start", "accountswitcher_header");
$plugins->add_hook("member_login", "accountswitcher_switch");
$plugins->add_hook("admin_user_groups_edit", "accountswitcher_admingroups_edit");
$plugins->add_hook("admin_user_groups_edit_commit", "accountswitcher_admingroups_commit");

function accountswitcher_info() {
	global $lang;

	$lang->load("accountswitcher");
	
	return array(
		"name"			=> $lang->as_name,
		"description"	=> $lang->as_desc,
		"author"		=> "Harest",
		"version"		=> "1.0",
		"compatibility"	=> "16*",
		"guid"			=> "302942f2b7bfd771fccae4824851dd9e"
	);
}
// install plugin
function accountswitcher_install() {
	global $db, $mybb, $cache;

	$db->query("ALTER TABLE `".TABLE_PREFIX."users` ADD `as_uid` INT(11) NOT NULL DEFAULT '0'");
	$db->query("ALTER TABLE `".TABLE_PREFIX."usergroups` ADD `as_canswitch` INT(1) NOT NULL DEFAULT '0', ADD `as_limit` SMALLINT(5) NOT NULL DEFAULT '0'");
	$cache->update_forums();
}
// check if plugin is installed
function accountswitcher_is_installed() {
	global $db;

	if($db->field_exists("as_uid", "users") && $db->field_exists("as_canswitch", "usergroups") && $db->field_exists("as_limit", "usergroups")) {
		return true;
	}
	else {
		return false;
	}
}
// activate plugin
function accountswitcher_activate() {
	global $db, $mybb, $lang;
	
	$lang->load("accountswitcher");
	
	$as_template[0] = array(
		"title" 	=> "as_usercp_nav",
		"template"	=> '<tr><td class="trow1 smalltext"><a href="usercp.php?action=as_edit" class="usercp_nav_item usercp_nav_usergroups">{$lang->as_name}</a></td></tr>',
		"sid"		=> -1,
		"version"	=> 1.0,
		"dateline"	=> TIME_NOW
	);
	$as_template[1] = array(
		"title" 	=> 'as_usercp',
		"template"	=> '<html><head><title>{$mybb->settings[\\\'bbname\\\']} - {$lang->as_name}</title>{$headerinclude}</head>
						<body>
						{$header}
						<table width="100%" border="0" align="center">
							<tr>
							{$usercpnav}
								<td valign="top">
									<table border="0" cellspacing="{$theme[\\\'borderwidth\\\']}" cellpadding="{$theme[\\\'tablespace\\\']}" class="tborder">
										<tr><td class="thead" colspan="2"><strong>{$lang->as_name}</strong></td></tr>
										<tr>
											<td class="trow1" valign="top">
												<fieldset class="trow2">
													<legend><strong>{$lang->as_usercp_options}</strong></legend>
													{$as_usercp_options}
												</fieldset>
											</td>
											{$as_usercp_users}
										</tr>
									</table>
								</td>
							</tr>
						</table>
						{$footer}
						</body>
						</html>',
		"sid"		=> -1,
		"version"	=> 1.0,
		"dateline"	=> TIME_NOW
	);
	$as_template[2] = array (
		"title" 	=> 'as_usercp_options',
		"template" 	=> '<form method="post" action="usercp.php">
						<input type="hidden" name="my_post_key" value="{$mybb->post_code}" />
							{$as_usercp_input}
						</table>
						</form>',
		"sid" 		=> -1,
		"version" 	=> 1.0,
		"dateline" 	=> TIME_NOW
	);
	$as_template[3] = array (
		"title" 	=> 'as_usercp_users',
		"template" 	=> '<td class="trow1" valign="top">
							<fieldset class="trow2">
								<legend><strong>{$lang->as_usercp_users}</strong></legend>
								<table cellspacing="0" cellpadding="{$theme[\\\'tablespace\\\']}">
									<tr><td>{$lang->as_usercp_attached}</td></tr>
									{$as_usercp_userbit}
								</table>
							</fieldset>
						</td>',
		"sid" 		=> -1,
		"version" 	=> 1.0,
		"dateline" 	=> TIME_NOW
	);
	$as_template[4] = array (
		"title" 	=> 'as_usercp_userbit',
		"template" 	=> '<tr><td>
							<form method="post" action="usercp.php">
							<input type="hidden" name="my_post_key" value="{$mybb->post_code}" />
							<input type="hidden" name="action" value="as_detachuser" />
							<input type="hidden" name="uid" value="{$attachedOneUID}" />
							<table width="100%" border="0" style="border:1px solid #000;margin:2px 0;padding:3px;" class="trow1">
								<tr>
									<td>{$attachedOneName}</td>
									<td align="right">
										<input type="submit" value="{$lang->as_detachuser}" name="{$lang->as_detachuser}" class="button" />
									</td>
								</tr>
							</table>
							</form>
						</td></tr>',
		"sid" 		=> -1,
		"version" 	=> 1.0,
		"dateline" 	=> TIME_NOW
	);
	$as_template[5] = array (
		"title" 	=> 'as_header',
		"template" 	=> '<hr />{$as_header_userbit}',
		"sid" 		=> -1,
		"version" 	=> 1.0,
		"dateline" 	=> TIME_NOW
	);
	foreach ($as_template as $row) {
		$db->insert_query("templates", $row);
	}
	require_once MYBB_ROOT."/inc/adminfunctions_templates.php";
	find_replace_templatesets('header_welcomeblock_member', '#{\$admincplink}#', '{\$admincplink}<!-- AccountSwitcher -->{$as_header}<!-- /AccountSwitcher -->');
}
// deactivate plugin
function accountswitcher_deactivate() {
	global $db;
	
	$db->delete_query("templates", "`title` = 'as_usercp_nav'");
	$db->delete_query("templates", "`title` = 'as_usercp'");
	$db->delete_query("templates", "`title` = 'as_usercp_users'");
	$db->delete_query("templates", "`title` = 'as_usercp_userbit'");
	$db->delete_query("templates", "`title` = 'as_header'");
	
	require_once MYBB_ROOT."/inc/adminfunctions_templates.php";
	find_replace_templatesets('header_welcomeblock_member', '#\<!--\sAccountSwitcher\s--\>(.+)\<!--\s/AccountSwitcher\s--\>#is', '', 0);
}
// uninstall plugin
function accountswitcher_uninstall() {
	global $db, $cache;
    
	$db->query("ALTER TABLE `".TABLE_PREFIX."users` DROP `as_uid`");
	$db->query("ALTER TABLE `".TABLE_PREFIX."usergroups` DROP `as_canswitch`, DROP `as_limit`");
	$cache->update_forums();
}

//########## FUNCTIONS ##########

// add to panel a list of users attached to account
function accountswitcher_header() {
	global $db, $mybb, $lang, $templates, $theme, $as_header;
	
	if($mybb->user['uid'] != "0") {
		$lang->load("accountswitcher");
		
		// get number of users attached to this account
		$count=$db->fetch_array($db->simple_select("users", "COUNT(as_uid) AS number", "as_uid={$mybb->user['uid']}"));
				
		// if there are users attached and current user can use the Account Switcher...
		if($count['number'] != "0" && $mybb->usergroup['as_canswitch'] == "1") {
			// ...get all attached ones...
			$getAttachedOnes=$db->simple_select("users", "uid, username", "as_uid={$mybb->user['uid']}");
			
			// ...and create a list of them
			while($attachedOne=$db->fetch_array($getAttachedOnes)) {
				// sanatize output
				$attachedOne['uid'] = (int)$attachedOne['uid'];
				$attachedOne['username'] = htmlspecialchars_uni($attachedOne['username']);
					
				$as_header_userbit.= "&nbsp;<a href='{$mybb->settings['bburl']}/member.php?action=login&amp;do=switch&amp;uid={$attachedOne['uid']}&amp;my_post_key={$mybb->post_code}'>{$attachedOne['username']}</a>";
			}
			eval("\$as_header = \"".$templates->get('as_header')."\";");
		}
		// if there are no users attached to current account but current account is attached to user
		if($count['number'] == "0" && $mybb->user['as_uid'] != '0') {
			// get master
			$master=$db->fetch_array($db->simple_select("users", "uid, username, usergroup", "uid={$mybb->user['as_uid']}"));
			// get masters permission
			$permission=$db->fetch_array($db->simple_select("usergroups", "as_canswitch", "gid={$master['usergroup']}"));
			
			// if master has paermission to user Account Switcher, get the userlist
			if($permission['as_canswitch'] == "1") {
				// create link to master
				$as_header_userbit.= "&nbsp;<a href='{$mybb->settings['bburl']}/member.php?action=login&do=switch&amp;uid={$master['uid']}&my_post_key={$mybb->post_code}'>{$master['username']}</a>";
				
				// get all users attached to master
				$getAttachedOnes=$db->simple_select("users", "uid, as_uid, username", "as_uid={$master['uid']}");
			
				// yet again create list of all attached ones...
				while($attachedOne=$db->fetch_array($getAttachedOnes)) {
					// sanatize output
					$attachedOne['uid'] = (int)$attachedOne['uid'];
					$attachedOne['username'] = htmlspecialchars_uni($attachedOne['username']);
					
					// leave current user out
					if($attachedOne['uid'] == "{$mybb->user['uid']}") continue;
					$as_header_userbit.= "&nbsp;<a href='{$mybb->settings['bburl']}/member.php?action=login&do=switch&amp;uid={$attachedOne['uid']}&my_post_key={$mybb->post_code}'>{$attachedOne['username']}</a>";
					
				}
				eval("\$as_header = \"".$templates->get('as_header')."\";");
			}
		}
	}
}
// the switch function
function accountswitcher_switch() {
	global $db, $mybb, $lang;
	
	if($mybb->user['uid'] != "0") {
		// get permission for this user
		$userPermission=$db->fetch_array($db->simple_select("usergroups", "as_canswitch", "gid={$mybb->user['usergroup']}"));
		// get permission for master. First get the master
		$master=$db->fetch_array($db->simple_select("users", "uid, username, usergroup", "uid={$mybb->user['as_uid']}"));
		// get his permission
		$masterPermission=$db->fetch_array($db->simple_select("usergroups", "gid, as_canswitch", "gid='{$master['usergroup']}'"));
		
		// if one of both has the permission allow to switch
		if($userPermission['as_canswitch'] == "1" || $masterPermission['as_canswitch'] == "1") {
			$lang->load("accountswitcher");
		
			verify_post_check($mybb->input['my_post_key']);
			
			// get the uid sanatized
			$user = get_user(intval($mybb->input['uid']));
			
			// check if user exists
			if(!$user) error($lang->as_invaliduser);
			
			// get the current page
			$redirect_url = htmlentities($_SERVER['HTTP_REFERER']);
			
			// make the switch!
			my_unsetcookie('mybbuser');
			my_setcookie('mybbuser', $user['uid'].'_'.$user['loginkey'], null, true);
			
			// redirect to page
			redirect($redirect_url, "");
			exit;
		}
	}
}
// add button to the usercp navigation
function accountswitcher_usercpmenu() {
	global $db, $mybb, $lang, $templates, $theme, $usercpmenu;
	
	$lang->load("accountswitcher");
	
	// show the button if user can use the Account Switcher or user is attached to an account
	if($mybb->usergroup['as_canswitch'] == "1" || $mybb->user['as_uid'] != "0") {
		eval("\$usercpmenu .= \"".$templates->get("as_usercp_nav")."\";");
	}
}
// get the usercp Account Switcher page and handle all actions
function accountswitcher_usercp() {
	global $db, $mybb, $lang, $templates, $theme, $headerinclude, $header, $usercpnav, $usercpmenu, $as_usercp, $as_usercp_options, $as_usercp_users, $as_usercp_userbit, $footer;
	
	$lang->load("accountswitcher");
	
	// get master of current user
	$master=$db->fetch_array($db->simple_select("users", "*", "uid={$mybb->user['as_uid']}"));
	
	// if user has no master
	// get number of attaches ones
	$count=$db->fetch_array($db->simple_select("users", "COUNT(as_uid) AS number", "as_uid={$mybb->user['uid']}"));
	// get users group
	$group=$db->fetch_array($db->simple_select("users", "usergroup", "uid={$mybb->user['uid']}"));
	// get limit for users group
	$limit=$db->fetch_array($db->simple_select("usergroups", "as_limit", "gid={$group['usergroup']}"));
	// get attached ones
	$getAttachedOne=$db->simple_select("users", "uid, username", "as_uid={$mybb->user['uid']}");
	
	
	
	
	// check if user can use the Account Switcher or is attached to an account. If yes permit access to page
	if($mybb->input['action'] == "as_edit" && ($mybb->usergroup['as_canswitch'] == "1" || $mybb->user['as_uid'] != "0")) {
		// if user is attached to an account he only can detach himself
		if($mybb->user['as_uid'] != "0") {
			$lang->as_isattached = $lang->sprintf($lang->as_isattached, $master['username']);
			
			// buid the detach button
			$as_usercp_input.= "<input type='hidden' name='action' value='as_detach' />
								<table width='100%' border='0'>
									<tr><td>{$lang->as_isattached}</td></tr>
									<tr><td>
										<input type='submit' value='{$lang->as_detach}' name='{$lang->as_detach}' class='button' />
									</td></tr>";
			eval("\$as_usercp_options = \"".$templates->get('as_usercp_options')."\";");
		}
		// if user is free
		else {
			// if limit set to 0 = unlimited
			if($limit['as_limit'] != "0") $lang->as_usercp_attached = $lang->sprintf($lang->as_usercp_attached, $count['number'], $limit['as_limit']);
			if($limit['as_limit'] == "0") $lang->as_usercp_attached = $lang->sprintf($lang->as_usercp_attached, $count['number'], $lang->as_unlimited);
			
			// if there are no users attached grant full acccess
			if($count['number'] == "0") {
				$as_usercp_input.= "<input type='hidden' name='action' value='as_attach' />
									<table width='100%' border='0'>
										<tr><td><input type='radio' name='select' value='attachuser' checked='ckeched' />&nbsp;{$lang->as_attachuser}<br /></td></tr>
										<tr><td><input type='radio' name='select' value='attachme' />&nbsp;{$lang->as_attachme}</td></tr>
										<tr><td><span class='smalltext'>{$lang->as_username}</span></td></tr>
										<tr><td><input type='text' name='username' size='30' /></td></tr>
										<tr><td><span class='smalltext'>{$lang->as_password}</span></td></tr>
										<tr><td><input type='password' name='password' size='30' /></td></tr>
										<tr><td>
											<input type='submit' value='{$lang->as_attach}' name='{$lang->as_attach}' class='button' />
										</td></tr>";
				eval("\$as_usercp_options = \"".$templates->get('as_usercp_options')."\";");
			}
			// if there are users attached allow only user attachment
			if($count['number'] != "0") {
				$as_usercp_input.= "<input type='hidden' name='action' value='as_attach' />
									<input type='hidden' name='select' value='attachuser' />
									<table width='100%' border='0'>
										<tr><td>{$lang->as_attachuser}</td></tr>
										<tr><td><span class='smalltext'>{$lang->as_username}</span></td></tr>
										<tr><td><input type='text' name='username' size='30' /></td></tr>
										<tr><td><span class='smalltext'>{$lang->as_password}</span></td></tr>
										<tr><td><input type='password' name='password' size='30' /></td></tr>
										<tr><td>
											<input type='submit' value='{$lang->as_attach}' name='{$lang->as_attach}' class='button' />
										</td></tr>";
				eval("\$as_usercp_options = \"".$templates->get('as_usercp_options')."\";");
				
				while($attachedOne=$db->fetch_array($getAttachedOne)) {
					// sanatize output
					$attachedOneUID = (int)$attachedOne['uid'];
					$attachedOneName = htmlspecialchars_uni($attachedOne['username']);
					eval("\$as_usercp_userbit .= \"".$templates->get('as_usercp_userbit')."\";");
				}
				eval("\$as_usercp_users = \"".$templates->get('as_usercp_users')."\";");
			}
		}
		eval("\$as_usercp = \"".$templates->get('as_usercp')."\";");
		output_page($as_usercp);
		die();
	}

//########## ACTIONS ##########
	// attach current user to an account
	if($mybb->input['action'] == "as_attach" && $mybb->input['select'] == "attachme" && $mybb->request_method == "post") {
		verify_post_check($mybb->input['my_post_key']);
		
		// check if current user is already attached
		if($mybb->user['as_uid'] != "0") error($lang->as_alreadyattached);
		
		// validate input
		$select = htmlspecialchars_uni($mybb->input['select']);
		$username = $db->escape_string(htmlspecialchars_uni($mybb->input['username']));
		$password = htmlspecialchars_uni($mybb->input['password']);
		
		// get the target
		$target=$db->fetch_array($db->simple_select("users", "uid, usergroup", "username='{$username}'"));
		// check targets permission and limit
		$permission=$db->fetch_array($db->simple_select("usergroups", "as_canswitch, as_limit", "gid={$target['usergroup']}"));
		// count number of attached accounts
		$count=$db->fetch_array($db->simple_select("users", "COUNT(as_uid) AS number", "as_uid={$target['uid']}"));
			
		// if target has permittion
		if($permission['as_canswitch'] == "0") error($lang->as_usercp_nopermission);
		if($permission['as_limit'] != "0" && $count['number'] == $permission['as_limit']) error($lang->as_limitreached);
		
		// set uid of new master
		$as_uid = array("as_uid" => $target['uid']);
			
		// update database
		$db->update_query("users", $as_uid, "uid={$mybb->user['uid']}");
		redirect("usercp.php?action=as_edit", "Account hat been attached successfully!");
	}
	// detach current user from master
	if($mybb->input['action'] == "as_detach" && $mybb->request_method == "post") {
		verify_post_check($mybb->input['my_post_key']);
		
		// reset master uid
		$as_uid = array("as_uid" => "0");
		
		// update database
		if($db->update_query("users", $as_uid, "uid={$mybb->user['uid']}")) {
			//if can use Account Switcher stay here
			if($mybb->usergroup['as_canswitch'] == "1") redirect("usercp.php?action=as_edit", "Account Switcher updated successfully!");
				
			// else redirect to usercp
				redirect("usercp.php", "Account detached successfully!");
		}
	}
	// attach user to current account
	if($mybb->input['action'] == "as_attach" && $mybb->input['select'] == "attachuser" && $mybb->request_method == "post" && $mybb->user['as_uid'] == "0") {
		verify_post_check($mybb->input['my_post_key']);
		// validate input
		$select = htmlspecialchars_uni($mybb->input['select']);
		$username = $db->escape_string(htmlspecialchars_uni($mybb->input['username']));
		$password = htmlspecialchars_uni($mybb->input['password']);
	
		// get the chosen one
		$chosenOne=$db->fetch_array($db->simple_select("users", "*", "username='{$username}'"));
		
		// check if user exists and password is correct
		$user = get_user(intval($chosenOne['uid']));
		if(!$user) error($lang->as_invaliduser);
		if(validate_password_from_uid($chosenOne['uid'], $password) == false) error($lang->as_invaliduser);
		
		// check allowed limit
		if($limit['as_limit'] != "0" && $limit['as_limit'] == $count['number']) error($lang->as_limitreached);
		
		// set his new masters uid
		$as_uid = array("as_uid" => $mybb->user['uid']);
			
		// update database
		$db->update_query("users", $as_uid, "uid={$chosenOne['uid']}");
		redirect("usercp.php?action=as_edit", "User hat been attached successfully!");
	}
	// detach user from current account
	if($mybb->input['action'] == "as_detachuser" && $mybb->request_method == "post") {
		verify_post_check($mybb->input['my_post_key']);
		// validate input
		if(!is_numeric($mybb->input['uid'])) die("Bow ties are cool.");
		
		// reset master uid
		$as_uid = array("as_uid" => "0");
			
		$db->update_query("users", $as_uid, "uid={$mybb->input['uid']}");
		redirect("usercp.php?action=as_edit", "User has been detached successfully!");
	
	}
}
// ##### admin #####
function accountswitcher_admingroups_edit() {
	global $plugins;
	
	// add new hook
	$plugins->add_hook("admin_formcontainer_end", "accountswitcher_admingroups_editform");
}
function accountswitcher_admingroups_editform() {
	global $mybb, $lang, $form, $form_container;
	
	$lang->load("accountswitcher");
	
	// create the input fields
	if($form_container->_title == $lang->misc) {
		$as_group_can = array(
			$form->generate_check_box("as_canswitch", 1, $lang->as_admin_canswitch, array("checked" => $mybb->input['as_canswitch']))
			//$form->generate_text_box("as_limit", $mybb->input['as_limit'], array('class' => 'field50'))
		);
		$as_group_limit = "<div class=\"group_settings_bit\">".$lang->as_admin_limit."<br />".$form->generate_text_box("as_limit", $mybb->input['as_limit'], array('class' => 'field50'))."</div>";
		$form_container->output_row($lang->as_name, "", "<div class=\"group_settings_bit\">".implode("</div><div class=\"group_settings_bit\">", $as_group_can)."</div>".$as_group_limit);
	}
}
function accountswitcher_admingroups_commit() {
	global $mybb, $updated_group;
	
	$updated_group['as_canswitch'] = $mybb->input['as_canswitch'];
	$updated_group['as_limit'] = $mybb->input['as_limit'];
}
?>